/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2009-08-21
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include <math.h>

#include "Average.h"
#include "Log.h"

namespace GpCoreTools {

/*!
  \class Average qtbaverage.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

Average::Average()
{
  _mean=0.0;
  _stddev=0.0;
}

void Average::calculate()
{
  unsigned int n=_values.size();
  double sum=0;
  double sum2=0;
  for(unsigned int i=0;i<n;i++) {
    double v=_values[i];
    sum+=v;
    sum2+=v*v;
  }
  _mean=sum/n;
  _stddev=(sum2-_mean*_mean*n)/(n-1);
  if(_stddev<0.0) _stddev=0.0;
  _stddev=sqrt(_stddev);
}

int Average::badValue(double factor) const
{
  double stddev3=factor*_stddev;
  unsigned int n=_values.size();
  for(unsigned int i=0;i<n;i++) {
    if(fabs(_values[i]-_mean)>stddev3) {
      return i;
    }
  }
  return -1;
}

void Average::remove(int i)
{
  unsigned int n=_values.size();
  _values[i]=_values[n-1];
  _values.resize(n-1);
}

} // namespace GpCoreTools
