/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2009-08-21
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include "Chrono.h"

namespace GpCoreTools {

/*!
  \class Chrono qtbchrono.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

Chrono::Chrono()
{
  clock_gettime(CLOCK_REALTIME, &_t);
}

void Chrono::start()
{
  clock_gettime(CLOCK_REALTIME, &_t);
}

/*!
  Returns the number of seconds elapsed since last start().
  If start() was not called, it returns the number of seconds
  since construction of this object.
*/
double Chrono::elapsed()
{
  timespec t;
  clock_gettime(CLOCK_REALTIME, &t);
  return (double)(t.tv_sec-_t.tv_sec)+(double)(t.tv_nsec-_t.tv_nsec)*1e-9;
}

} // namespace GpCoreTools
