/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2010-02-03
**  Authors:
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include <sys/socket.h>
#include <sys/un.h>
#include <assert.h>
#include <unistd.h>

#include "CoreApplication.h"
#include "EventStream.h"
#include "EventLoop.h"
#include "Event.h"
#include "Log.h"
#include "Trace.h"

namespace GpCoreTools {

/*!
  \class EventStream EventStream.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
EventStream::EventStream()
    : Stream()
{
  TRACE;
  socketpair(AF_UNIX, SOCK_STREAM, 0, _sockets);
  setFileDescriptor(_sockets[0]);
}

/*!
  Description of destructor still missing
*/
EventStream::~EventStream()
{
  TRACE;
  if(_sockets[1]) {
    ::close(_sockets[1]);
  }
}

void EventStream::send(Event * event)
{
  UNUSED(::write(_sockets[1], (const char *)&event, sizeof(Event *)));
}

void EventStream::event(short type)
{
  TRACE;
  if(type & POLLIN) {
    Event * event;
    if(::read(_sockets[0], (char *)&event, sizeof(Event *))==sizeof(Event *)) {
      EventLoop::instance()->addEvent(event);
    } else {
      Log::write(6, "uncomplete event pointer");
    }
  }
  if(type & POLLRDHUP) {
    assert(false);
  }
}

} // namespace GpCoreTools
