/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2010-02-03
**  Authors:
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#ifndef EVENTSTREAM_H
#define EVENTSTREAM_H

#include <poll.h>

#include "Stream.h"
#include "GpCoreToolsDLLExport.h"

namespace GpCoreTools {

class Event;

class GPCORETOOLS_EXPORT EventStream : public Stream
{
public:
  EventStream();
  ~EventStream();

  virtual short eventTypes() {return POLLIN | POLLRDHUP;}
  virtual void event(short type);

  void send(Event * event);
private:
  int _sockets[2];
};

} // namespace GpCoreTools

#endif // EVENTSTREAM_H
