/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2009-07-02
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#ifndef FILE_H
#define FILE_H

#include <stdio.h>
#include <string>
#include <vector>

#include "GpCoreToolsDLLExport.h"

namespace GpCoreTools {

class GPCORETOOLS_EXPORT File
{
public:
  static bool readLine(char *& buf, int& bufLen, FILE * f, bool delEOL=false);
  static std::vector<std::string> * complete(const std::string& beginFilePath);
  static bool match(const char * buffer, int& bytesRead, int bytesCount, const char * string);
  static char * readAll(const char * fileName);
  static int readInteger(const char * buffer, int& bytesRead, int bytesCount, bool& ok);
  static long int readLongInteger(const char * buffer, int& bytesRead, int bytesCount, bool& ok);
  static double readDouble(const char * buffer, int& bytesRead, int bytesCount, bool& ok);
};

} // namespace GpCoreTools

#endif // FILE_H
