/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2009-06-27
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "InfiniteLoop.h"
#include "Log.h"

namespace GpCoreTools {

/*!
  \class InifiniteLoop qtbinifiniteloop.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
InfiniteLoop::InfiniteLoop()
{
  _state=NotRunning;
}

/*!
  Description of destructor still missing
*/
InfiniteLoop::~InfiniteLoop()
{
  if(isRunning()) {
    Log::write(1, "loop destroyed while running\n");
  }
}

/*!
  Wait a maximum of 10 seconds for process to end.
*/
void InfiniteLoop::wait()
{
  int elapsed=0;
  while(isRunning() && elapsed<1000) {
    usleep(10000);  // 10 ms
    elapsed++;
  }
  if(elapsed==1000) {
    Log::write(0, "time out\n");
  }
}

} // namespace GpCoreTools
