/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2011-06-21
**  Authors:
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#ifndef MOVINGSTATISTICS_H
#define MOVINGSTATISTICS_H

#include "Statistics.h"

namespace GpCoreTools {

  class GPCORETOOLS_EXPORT MovingStatistics: public Statistics
  {
  public:
    MovingStatistics();
    MovingStatistics(int size);
    ~MovingStatistics();

    void add(double val);
    void addMinMax(double val);
    void set(double val);
    void reset(int size);
  private:
    double * _values;
    int _currentIndex;
    int _size;
  };

} // namespace GpCoreTools

#endif // MOVINGSTATISTICS_H
