/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2014-03-05
**  Copyright: 2014
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#include <assert.h>
#include <cstdarg>
#include <stdio.h>
#include <string.h>

#include "Trace.h"
#include "Log.h"
#include "ScreenClient.h"

namespace GpCoreTools {

  /*!
    \class ScreenClient ScreenClient.h
    \brief Brief description of class still missing

    Full description of class still missing
  */

  ScreenClient * ScreenClient::_self=0;

  ScreenClient::ScreenClient(const Address& host, uint16_t port)
    : StaticTcpClient(host, port)
  {
    assert(!_self);
    _self=this;
  }

  void ScreenClient::write(unsigned char x, unsigned char y, const char * cformat,...)
  {
    TRACE;
    char buf[32]; // No more than 20 characters at a time
    buf[0]=17;
    buf[1]=x;
    buf[2]=y;
    va_list argptr;
    va_start(argptr, cformat);
    char * msgBuf=buf+3;
    vsnprintf(msgBuf, 28, cformat, argptr);
    va_end(argptr);
    int n=strlen(msgBuf);
    if(n>20) {
      Log::write(0, "More than 20 characters\n");
      Log::write(0, "'%s'\n", msgBuf);
      n=20;
    }
    n+=3;
    _self->StaticTcpClient::writePacket(buf, n);
  }

} // namespace GpCoreTools
