/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2011-06-20
**  Authors:
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#ifndef STATICTCPCLIENT_H
#define STATICTCPCLIENT_H

#include "TcpClientStream.h"
#include "GpCoreToolsDLLExport.h"

namespace GpCoreTools {

  class GPCORETOOLS_EXPORT StaticTcpClient : public TcpClientStream
  {
  public:
    StaticTcpClient(const Address& host, uint16_t port);

    virtual void hungUp();
    void connect();

    void writePacket(const char * buf, int n);
    void writePacket(const char * cformat,...);

    void writeText(const char * buf, int n);
    void writeText(const char * cformat,...);
  private:
    uint16_t _port;
    bool _connected;
    pthread_mutex_t _mutex;
  };

} // namespace GpCoreTools

#endif // STATICTCPCLIENT_H
