/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2009-07-01
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include <math.h>

#include "Statistics.h"

namespace GpCoreTools {

/*!
  \class Statistics Statistics.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
Statistics::Statistics()
{
  reset();
}

void Statistics::add(double val)
{
  _sum+=val;
  _sum2+=val*val;
  if(val<_minimum) _minimum=val;
  if(val>_maximum) _maximum=val;
  _count++;
}

void Statistics::set(double val)
{
  _sum=val;
  _sum2=val*val;
  _minimum=val;
  _maximum=val;
  _count=1;
}

void Statistics::reset()
{
  _sum=0.0;
  _sum2=0.0;
  _minimum=-INFINITY;
  _maximum=INFINITY;
  _count=0;
}

double Statistics::mean() const
{
  switch(_count) {
  case 0:
    return 0.0;
  case 1:
    return _sum;
  default:
    return _sum/_count;
  }
}

double Statistics::stddev() const
{
  if(_count<2) {
    return 0.0;
  } else {
    double s=(_sum2-_sum*_sum/_count)/(_count-1);
    if(s<0.0) s=0.0;
    return sqrt(s);
  }
}

} // namespace GpCoreTools
