/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2008-10-20
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include "TraceBug.h"
#include "PThread.h"
#include "CoreApplication.h"

namespace GpCoreTools {

/*!
  \class TraceBug qtbtracebug.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

std::vector<TraceBug *> TraceBug::_mainStack;

/*!
  Description of constructor still missing
*/
TraceBug::TraceBug(const TraceStamp * s)
{
  PThread * t=PThread::currentThread();
  if(t) {
    _myStack=t->bugStack();
    _myStack->push_back(this);
  } else {
    _myStack=&_mainStack;
    _myStack->push_back(this);
  }
  _stamp=s;
}

/*!
  Description of destructor still missing
*/
TraceBug::~TraceBug()
{
  if(_myStack) {
    _myStack->pop_back();
  }
}

std::string TraceBug::backTrace(const std::vector<TraceBug *> * stack)
{
  std::string list;

  for(std::vector<TraceBug *>::const_reverse_iterator it=stack->rbegin();it!=stack->rend();it--) {
    list += (*it)->toString();
  }
  return list;
}

std::string TraceBug::toString() const
{
  std::string str;
  str+=_stamp->toString() + "\n";
  for(std::list<TraceInfo>::const_iterator it=_infos.begin();it!=_infos.end();it++) {
    str+="  "+it->toString() + "\n";
  }
  return str;
}

} // namespace GpCoreTools
