/***************************************************************************
**
**  This file is part of GpCoreTools.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2008-10-20
**  Authors:
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include "TraceStamp.h"
#include "Variant.h"

namespace GpCoreTools {

/*!
  \class TraceStamp qtbtracestamp.h
  \brief Storage for trace stamps

  Storage for trace stamps. Stamps are collected each time macro TRACE is encountered.
*/

/*!
  \fn TraceStampData::TraceStamp(const char * functionName, int lineNumber)
  Stores function name and line number.
*/

/*!
  Returns a string describing the code stamp: filename:linenumber.
*/
std::string TraceStamp::toString() const
{
  std::string str(_functionName);
  str+=":";
  Variant val(_lineNumber);
  str+=val.toString();
  return str;
}


} // namespace GpCoreTools
